/* Button */
:where(button, .button, input[type="submit"]) {
  padding: var(--margin-sm) var(--margin);

  display: inline-flex;
  align-items: center;
  gap: var(--margin-sm);

  background: var(--button-background);
  border: none;
  outline: none;
  border-radius: var(--border-radius);

  color: inherit;
  font-size: 1rem;
  font-family: inherit;
  font-weight: 400;
  text-decoration: none;

  cursor: pointer;
  transition: background var(--transition-duration);

  --button-background: var(--color-secondary);
  --button-background-hover: var(--color-secondary-h1);
  --button-background-active: var(--color-primary);
  --button-background-active-hover: var(--color-primary-h1);
}

:where(button, .button, input[type="submit"]):is(:hover, :focus, :focus-within) {
  background: var(--button-background-hover);
}

/* Primary button  */
:where(button, .button, input[type="submit"]).primary {
  --button-background: var(--color-primary);
  --button-background-hover: var(--color-primary-h1);
}

/* Transparent button */
:where(button, .button, input[type="submit"]).transparent {
  --button-background: transparent;
  --button-background-hover: var(--color-secondary);
}

/* Primary and transparent button */
:where(button, .button, input[type="submit"]).primary.transparent {
  --button-background: transparent;
  --button-background-hover: var(--color-primary-h1);
}

/* Compact button*/
:where(button, .button, input[type="submit"]).compact {
  padding: var(--margin-sm);
}

/* Link button */
:where(button, .button, input[type="submit"]).link {
  padding: var(--margin-sm) var(--margin);

  --button-background: transparent;
  --button-background-hover: transparent;
}

:where(button, .button, input[type="submit"]).link:is(:hover,:focus) > *:not(.icon) {
  text-decoration: underline;
}

/* Sharp button */
:where(button, .button, input[type="submit"]).sharp {
  border-radius: 0;
}

/* Circle button */
:where(button, .button, input[type="submit"]).circle {
  width: 2.5rem;
  aspect-ratio: 1 / 1;
  padding: var(--margin-sm);

  place-content: center;

  border-radius: 50%;
}

/* Pill button */
:where(button, .button, input[type="submit"]).pill {
  border-radius: 1000px; /* Very large for pill shape. */
}

/* Outline button */
:where(button, .button, input[type="submit"]).outline {
  border: var(--border-size) solid var(--color-border);

  --button-background: transparent;
  --button-background-hover: var(--color-background-l1);
}

/* Image button */
:where(button, .button).image {
  position: relative;
  padding: 0;
  justify-content: center;

  overflow: hidden;
}

:where(button, .button).image::after {
  content: "";
  position: absolute;
  inset: 0 0 0 0;

  background-color: var(--button-background-hover);
  opacity: 0;

  transition: opacity var(--transition-duration);
}

:where(button, .button).image:is(:hover,:focus)::after {
  opacity: 0.3;
}

:where(button, .button) > img {
  height: 100%;
  width: 100%;
  object-fit: cover;
}

/* Disabled */
:where(button, .button, input[type="submit"]):disabled {
  color: var(--color-muted);
  cursor: initial;

  --button-background: var(--color-secondary);
  --button-background-hover: var(--color-secondary);
}

/* Supporting text utilities */
:where(button, .button, input[type="submit"]).text-center {
  justify-content: center;
}